'=========================================================================================
' Installation Script by Tadis
'=========================================================================================

Option Explicit
Dim WshShell, fso, oExec, oShell, oFolder, oFolderItem, oShellLink, strSamPath, strDesktop, strScriptPath, NewPath

Set WshShell = WScript.CreateObject("WScript.Shell")
set oShell = CreateObject("Shell.Application")

CONST keySamPath = "HKCU\Software\Serious Samurize\"
NewPath = WshShell.RegRead (keySamPath)
CONST OldPath = "C:\Program Files\Samurize"

strScriptPath = Left(WScript.ScriptFullName, ( Len(WScript.ScriptFullName) - Len(WScript.ScriptName) ) )
strSamPath = GetSamPath
FolderCopy (strScriptPath & "*") , strSamPath , 1
WScript.Sleep (500)
NameFiles(NewPath & "\Configs\Vertical Media")

MediaShortcut
WScript.Sleep (100)
ArtShortcut

Set oExec = Nothing
Set WshShell = Nothing
Set oShell = Nothing

Wscript.Echo "Installation Complete"

'=========================================================================================

Function MediaShortcut()
Dim strKey
strKey = "HKCU\Software\Serious Samurize\Instance VerticalMedia\"
WshShell.RegWrite strKey , 0 ,"REG_DWORD"
WshShell.RegWrite strKey & "ConfigFile", "Vertical Media\VerticalOpen.ini"
WshShell.RegWrite strKey & "Locked", "0"
WshShell.RegWrite strKey & "ClickThrough", "0"
WshShell.RegWrite strKey & "UseDesignedPosition", "0"
WshShell.RegWrite strKey & "OffsetX", 300 , "REG_DWORD"
WshShell.RegWrite strKey & "OffsetY", 100 , "REG_DWORD"
WshShell.RegWrite strKey & "WindowStatus", 1 , "REG_DWORD"
strDesktop			= WSHShell.SpecialFolders("Desktop")
set oShellLink			= WSHShell.CreateShortcut(strDesktop & "\Vertical Media Widget.lnk")
oShellLink.Description		= "Samurize Widget"
oShellLink.TargetPath		= strSamPath & "\Scripts\Vertical Media\RestartMedia.vbs"
oShellLink.IconLocation		= strSamPath & "\Icons\VIcon.ico"
oShellLink.WorkingDirectory	= strSamPath
oShellLink.Save()
End Function

'=========================================================================================

Function ArtShortcut()
Dim strKey
strKey = "HKCU\Software\Serious Samurize\Instance VerticalArt\"
WshShell.RegWrite strKey , 0 ,"REG_DWORD"
WshShell.RegWrite strKey & "ConfigFile", "Vertical Media\Album Art.ini"
WshShell.RegWrite strKey & "Locked", "0"
WshShell.RegWrite strKey & "ClickThrough", "0"
WshShell.RegWrite strKey & "UseDesignedPosition", "0"
WshShell.RegWrite strKey & "OffsetX", 300 , "REG_DWORD"
WshShell.RegWrite strKey & "OffsetY", 150 , "REG_DWORD"
WshShell.RegWrite strKey & "WindowStatus", 1 , "REG_DWORD"
strDesktop			= WSHShell.SpecialFolders("Desktop")
set oShellLink			= WSHShell.CreateShortcut(strDesktop & "\Vertical Media Album Art Widget.lnk")
oShellLink.Description		= "Samurize Widget"
oShellLink.TargetPath		= strSamPath & "\Scripts\Vertical Media\RestartArt.vbs"
oShellLink.IconLocation		= strSamPath & "\Icons\VIcon.ico"
oShellLink.WorkingDirectory	= strSamPath
oShellLink.Save()
End Function

'=========================================================================================

Function FolderCopy(SourcePath, DestinationPath, Overwrite)
Set fso = CreateObject("Scripting.FileSystemObject")
fso.CopyFolder SourcePath, DestinationPath, Overwrite
Set fso = Nothing
End Function

'=========================================================================================

Function GetSamPath()
On Error Resume Next

Set fso = CreateObject("Scripting.FileSystemObject")
GetSamPath = WshShell.RegRead (keySamPath)

If Err.Number <> 0 Then
  Wscript.Echo "I can't find your Samurize installation, please find it for me."
  GetSamPath = Browse("Please locate your Samurize Folder:")
  
  If Not (fso.FileExists(GetSamPath & "\Client.exe")) Then

    GetSamPath = False
    Wscript.Echo "This is not the valid Samurize path"
    Wscript.Quit
  End If

End If

WshShell.RegWrite KeySamPath & "\General\", 0 ,"REG_DWORD"
WshShell.RegWrite KeySamPath & "\General\DirPath", (GetSamPath & "\")

Set fso = Nothing
End Function

'=========================================================================================

Function Browse(strMess)
On Error Resume Next

Set oShell = CreateObject("Shell.Application")
Set oFolder = oShell.BrowseForFolder(0, strMess, 0)
set oFolderItem = oFolder.Items.Item

If (Not oFolderItem Is Nothing) Then
   Browse = oFolderItem.Path
End If

Set oShell = Nothing
Set oFolder = Nothing
Set oFolderItem = Nothing
End Function

'=========================================================================================

Function NameFiles(folder)
Dim vFolder, vSubFolder, vFile, VExtension, vFileTemp, vExt
Set fso = CreateObject("Scripting.FileSystemObject")
Set vFolder = fso.GetFolder(folder)

vExt = "ini"

For each vFile in vFolder.Files
   vExtension = Right(vFile , 3)
   If vExtension = vExt Then 
      vFileTemp = Readini (vFile)
      vFileTemp = Replace(vFileTemp, OldPath , NewPath)
      Createini vFile , vFileTemp
   End If
Next

For each vSubFolder in vFolder.Subfolders
   NameFiles(vSubFolder)
Next

Set fso = Nothing
Set vFolder = Nothing
End Function

'=========================================================================================

Function Readini(rFile)
Dim rfso, rInFile, strLen, strPathr
Const ForReading = 1, ForWriting = 2, ForAppending = 8

strPathr = rFile
Set rfso = CreateObject("Scripting.FileSystemObject")
Set rInFile = rfso.OpenTextFile(strPathr, ForReading)
Readini = rInFile.ReadAll

set rfso = Nothing
rInFile.Close
End Function

'=========================================================================================

Function Createini(vFile, vText)
Dim fso, InFile, OutFile, strText
Set fso = CreateObject("Scripting.FileSystemObject")
Set OutFile = fso.CreateTextFile(vFile, True)

strText = vText
OutFile.Write(strText)

OutFile.Close
set fso = Nothing
End Function

'=========================================================================================